package medium;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.Scanner;

	// TODO:
	// - lg[] zu Objekt hinzufgen
	// - Medium Einlesen berprfen ob INT und dann wieder einlesen
	// - Array gre berprfen

public class Verwaltung {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws FileNotFoundException 
	 * @throws ClassNotFoundException 
	 * @throws Exception 
	 */
	public static void main(String[] args) throws FileNotFoundException, IOException, ClassNotFoundException {
		// Array benoetig feste Groesse
		// Alternative ArrayList
		Leihgut lg[] = new Leihgut[10];
		int lgIndexAnzahl = 0;

		Scanner scanner = new Scanner( System.in );
		char cmd;
	
		do {
			System.out.println("\nKommando m, v, l, o, i, d, q:");
			cmd = scanner.next().charAt(0);
			
			switch (cmd) {
				case 'm':
					// FIX
					if(lg.length > lgIndexAnzahl) {
						lg[lgIndexAnzahl] = new Medium();
						++lgIndexAnzahl;
					} else {
						System.out.println("Array voll");
					}
					break;
				case 'v':
					if(lg.length > lgIndexAnzahl) {
						lg[lgIndexAnzahl] = new Video();
						++lgIndexAnzahl;
					} else {
						System.out.println("Array voll");
					}
					break;
				/* Deaktiviert fr Aufgabe 2
				case 'e':
					if(lg != null)
						lg.leihen();
					break;
				case 'r':
					if(lg != null)
						lg.rueck();
					break; */
				case 'l':
					Medium.print_head();
					for(int i = 0; i < lg.length; ++i) {
						if( lg[i] != null )
							System.out.println(lg[i]);
					}
					break;
				case 'o':
					Scanner fileNameScanner = new Scanner( System.in );
					System.out.print("Dateiname: ");
					String fileName = fileNameScanner.next();
					
					ObjectOutputStream oos = new ObjectOutputStream(new FileOutputStream(fileName));
					oos.writeObject(lg);
					oos.close();
					break;
				case 'i':
					Scanner fileNameScannerIn = new Scanner( System.in );
					System.out.print("Dateiname: ");
					String fileNameIn = fileNameScannerIn.next();
					
					ObjectInputStream ois = new ObjectInputStream(new FileInputStream(fileNameIn));
					Leihgut tmp[] = (Leihgut[])ois.readObject();
					
					// FIX
					if( arraySize(tmp) >= lg.length || arraySize(tmp) >= (lg.length-arraySize(lg)) ) {
						System.out.println("Array in Datei zu gross");
					} else {
						// Fuege Object zu Array hinzu
						for( int i=0; i<tmp.length; ++i ) {
							if( tmp[i] != null ) {
								lg[lgIndexAnzahl] = tmp[i];
								++lgIndexAnzahl;
							}
						}
					}
					
					ois.close();
					break;
				case 'd':
					Scanner pathNameScanner = new Scanner( System.in );
					System.out.print("Pfad: ");
					
					File pathDir = new File(pathNameScanner.next());
					String content[] = pathDir.list();
					for(int f = 0; f < content.length; ++f) {
						System.out.println(content[f]);
					}
					break;
				case 'q':
					break;
				default:
					System.out.println("Falsches Kommando");     
		    }
		} while (cmd != 'q');
	}
	
	// FIX
	private static int arraySize(Leihgut lg[]) {
		int count = 0;
		while(lg[count] != null && lg.length > count) {
			++count;
		}
		return count;
	}

}
